"""Stream type classes for tap-suiss-buildings."""

from pathlib import Path
from typing import Any, Dict, Optional, Union, List, Iterable

from singer_sdk import typing as th  # JSON Schema typing helpers

from tap_suisse_buildings.client import TapGWRStreamBase

SCHEMAS_DIR = Path(__file__).parent / Path("./schemas")

class TapSuisseCodesStream(TapGWRStreamBase):
    name = "gwr_codes"
    primary_keys = ["CECODID","CMERKM"]
    replication_key = None
    dataset = "codes"
    schema = th.PropertiesList(
         th.Property(
            "CECODID",
            th.StringType,
        ),
        th.Property(
            "CMERKM",
            th.StringType,
        ),
        th.Property(
            "CODTXTLD",
            th.StringType,
        ),
        th.Property(
            "CODTXTKD",
            th.StringType,
        ),
        th.Property(
            "CODTXTLF",
            th.StringType,
        ),
        th.Property(
            "CODTXTKF",
            th.StringType,
        ),
        th.Property(
            "CODTXTLI",
            th.StringType,
        ),
        th.Property(
            "CODTXTKI",
            th.StringType,
        ),
        th.Property(
            "CEXPDAT",
            th.StringType,
        ),
    ).to_dict()


class TapSuisseBuildingStream(TapGWRStreamBase):
    name = "gwr_buildings"
    primary_keys = ["EGID"]
    replication_key = None
    schema = th.PropertiesList(
        th.Property(
            "EGID",
            th.StringType,
        ),
        th.Property(
            "GDEKT",
            th.StringType,
        ),
        th.Property(
            "GGDENR",
            th.StringType,
        ),
        th.Property(
            "GGDENAME",
            th.StringType,
        ),
        th.Property(
            "EGRID",
            th.StringType,
        ),
        th.Property(
            "LGBKR",
            th.StringType,
        ),
        th.Property(
            "LPARZ",
            th.StringType,
        ),
        th.Property(
            "LPARZSX",
            th.StringType,
        ),
        th.Property(
            "LTYP",
            th.StringType,
        ),
        th.Property(
            "GEBNR",
            th.StringType,
        ),
        th.Property(
            "GBEZ",
            th.StringType,
        ),
        th.Property(
            "GKODE",
            th.StringType,
        ),
        th.Property(
            "GKODN",
            th.StringType,
        ),
        th.Property(
            "GKSCE",
            th.StringType,
        ),
        th.Property(
            "GSTAT",
            th.StringType,
        ),
        th.Property(
            "GKAT",
            th.StringType,
        ),
        th.Property(
            "GKLAS",
            th.StringType,
        ),
        th.Property(
            "GBAUJ",
            th.StringType,
        ),
        th.Property(
            "GBAUM",
            th.StringType,
        ),
        th.Property(
            "GBAUP",
            th.StringType,
        ),
        th.Property(
            "GABBJ",
            th.StringType,
        ),
        th.Property(
            "GAREA",
            th.StringType,
        ),
        th.Property(
            "GVOL",
            th.StringType,
        ),
        th.Property(
            "GVOLNORM",
            th.StringType,
        ),
        th.Property(
            "GVOLSCE",
            th.StringType,
        ),
        th.Property(
            "GASTW",
            th.StringType,
        ),
        th.Property(
            "GANZWHG",
            th.StringType,
        ),
        th.Property(
            "GAZZI",
            th.StringType,
        ),
        th.Property(
            "GSCHUTZR",
            th.StringType,
        ),
        th.Property(
            "GEBF",
            th.StringType,
        ),
        th.Property(
            "GWAERZH1",
            th.StringType,
        ),
        th.Property(
            "GENH1",
            th.StringType,
        ),
        th.Property(
            "GWAERSCEH1",
            th.StringType,
        ),
        th.Property(
            "GWAERDATH1",
            th.StringType,
        ),
        th.Property(
            "GWAERZH2",
            th.StringType,
        ),
        th.Property(
            "GENH2",
            th.StringType,
        ),
        th.Property(
            "GWAERSCEH2",
            th.StringType,
        ),
        th.Property(
            "GWAERDATH2",
            th.StringType,
        ),
        th.Property(
            "GWAERZW1",
            th.StringType,
        ),
        th.Property(
            "GENW1",
            th.StringType,
        ),
        th.Property(
            "GWAERSCEW1",
            th.StringType,
        ),
        th.Property(
            "GWAERDATW1",
            th.StringType,
        ),
        th.Property(
            "GWAERZW2",
            th.StringType,
        ),
        th.Property(
            "GENW2",
            th.StringType,
        ),
        th.Property(
            "GWAERSCEW2",
            th.StringType,
        ),
        th.Property(
            "GWAERDATW2",
            th.StringType,
        ),
        th.Property(
            "GEXPDAT",
            th.StringType,
        ),
    ).to_dict()

class TapSuisseEntranceStream(TapGWRStreamBase):
    name = "gwr_entrances"
    primary_keys = ["EGID","EDID"]
    replication_key = None
    dataset = "entrances"
    schema = th.PropertiesList(
         th.Property(
            "EGID",
            th.StringType,
        ),
        th.Property(
            "EDID",
            th.StringType,
        ),
        th.Property(
            "EGAID",
            th.StringType,
        ),
        th.Property(
            "DEINR",
            th.StringType,
        ),
        th.Property(
            "ESID",
            th.StringType,
        ),
        th.Property(
            "STRNAME",
            th.StringType,
        ),
        th.Property(
            "STRNAMK",
            th.StringType,
        ),
        th.Property(
            "STRINDX",
            th.StringType,
        ),
        th.Property(
            "STRSP",
            th.StringType,
        ),
        th.Property(
            "STROFFIZIEL",
            th.StringType,
        ),
        th.Property(
            "DPLZ4",
            th.StringType,
        ),
        th.Property(
            "DPLZZ",
            th.StringType,
        ),
        th.Property(
            "DPLZNAME",
            th.StringType,
        ),
        th.Property(
            "DKODE",
            th.StringType,
        ),
        th.Property(
            "DKODN",
            th.StringType,
        ),
        th.Property(
            "DOFFADR",
            th.StringType,
        ),
        th.Property(
            "DEXPDAT",
            th.StringType,
        ),
    ).to_dict()

class TapSuisseApartmentStream(TapGWRStreamBase):
    name = "gwr_apartments"
    primary_keys = ["EGID","EWID"]
    replication_key = None
    dataset = "apartments"
    schema = th.PropertiesList(
         th.Property(
            "EGID",
            th.StringType,
        ),
        th.Property(
            "EWID",
            th.StringType,
        ),
        th.Property(
            "EDID",
            th.StringType,
        ),
        th.Property(
            "WHGNR",
            th.StringType,
        ),
        th.Property(
            "WEINR",
            th.StringType,
        ),
        th.Property(
            "WSTWK",
            th.StringType,
        ),
        th.Property(
            "WBEZ",
            th.StringType,
        ),
        th.Property(
            "WMEHRG",
            th.StringType,
        ),
        th.Property(
            "WBAUJ",
            th.StringType,
        ),
        th.Property(
            "WABBJ",
            th.StringType,
        ),
        th.Property(
            "WSTAT",
            th.StringType,
        ),
        th.Property(
            "WAREA",
            th.StringType,
        ),
        th.Property(
            "WAZIM",
            th.StringType,
        ),
        th.Property(
            "WKCHE",
            th.StringType,
        ),
        th.Property(
            "WEXPDAT",
            th.StringType,
        ),
    ).to_dict()
